/* eslint-disable */
import React from 'react';
import { AppProvider } from 'fz-i18n';
import renderer from 'react-test-renderer';
import { licensePermissionCheckHOC } from '../licensePermissionCheckHOC';
import configureStore from 'redux-mock-store';

var permission = {
	ticket: {
		create: true,
		view: true
	},
	flags: {
		administratorDashboard: true
	}
};
describe("licensePermissionCheckHOC", function () {
	it("test1", function () {
		var Temp = function Temp() {
			return React.createElement(
				'div',
				null,
				'Test'
			);
		};
		Temp = licensePermissionCheckHOC({ component: { license: "*", permission: "ticket_view" } })(Temp);

		var ele = renderer.create(React.createElement(
			AppProvider,
			{ store: configureStore()({}), permission: permission,
				user: { id: "1", name: "vimal" }, timeZone: 'Asia/kolkata' },
			React.createElement(Temp, null)
		));
		var tree = ele.toJSON();
		expect(tree).toMatchSnapshot();
	});
	fit("test2", function () {
		var Temp = function Temp(_ref) {
			var data = _ref.data;
			return React.createElement(
				'div',
				null,
				data
			);
		};
		Temp = licensePermissionCheckHOC({
			props: {
				agents: function agents(props) {
					return {
						permission: "*_administratorDashboard",
						obj: props.data,
						falseObj: null
					};
				}
			}
		})(Temp);

		var ele = renderer.create(React.createElement(
			AppProvider,
			{ store: configureStore()({}), permission: permission,
				user: { id: "1", name: "vimal" }, timeZone: 'Asia/kolkata' },
			React.createElement(Temp, { data: 'vimal' })
		));
		var tree = ele.toJSON();
		expect(tree).toMatchSnapshot();
	});
});