import _Object$keys from 'babel-runtime/core-js/object/keys';
import _extends from 'babel-runtime/helpers/extends';
import _Object$getPrototypeOf from 'babel-runtime/core-js/object/get-prototype-of';
import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _createClass from 'babel-runtime/helpers/createClass';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';
import React from 'react';
import selectn from 'selectn';
import PropTypes from 'prop-types';
import { permissionCheck, licenseCheck } from '../utils';
import { PermissionContext } from '../PermissionContext';

var HigherOrderPermission = function (_React$Component) {
  _inherits(HigherOrderPermission, _React$Component);

  function HigherOrderPermission(props, context) {
    _classCallCheck(this, HigherOrderPermission);

    var _this = _possibleConstructorReturn(this, (HigherOrderPermission.__proto__ || _Object$getPrototypeOf(HigherOrderPermission)).call(this, props, context));

    _this.currentPermission = props.permission || selectn('permission', context);
    _this.currentLicense = props.license || selectn('license', context);
    return _this;
  }

  _createClass(HigherOrderPermission, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          proxyPropsObjHasFunction = _props.proxyPropsObjHasFunction,
          getLicenseProfileCheck = _props.getLicenseProfileCheck,
          Component = _props.Component,
          Fallback = _props.Fallback;

      var props = proxyPropsObjHasFunction ? this.props : {};

      var _getLicenseProfileChe = getLicenseProfileCheck(props, this.currentPermission, this.currentLicense),
          licenseSuccess = _getLicenseProfileChe.licenseSuccess,
          permissionSuccess = _getLicenseProfileChe.permissionSuccess,
          permissionProps = _getLicenseProfileChe.permissionProps;

      if (licenseSuccess && permissionSuccess) {
        return React.createElement(Component, _extends({}, this.props, permissionProps));
      } else if (Fallback) {
        return React.createElement(Fallback, this.props);
      }
      return null;
    }
  }]);

  return HigherOrderPermission;
}(React.Component);

HigherOrderPermission.contextType = PermissionContext;

HigherOrderPermission.propTypes = {
  Component: PropTypes.element,
  Fallback: PropTypes.element,
  getLicenseProfileCheck: PropTypes.func,
  license: PropTypes.string,
  permission: PropTypes.object,
  proxyPropsObjHasFunction: PropTypes.func
};

export var licensePermissionCheckHOC = function licensePermissionCheckHOC(_ref) {
  var _ref$component = _ref.component,
      component = _ref$component === undefined ? { license: '*', permission: '*' } : _ref$component,
      _ref$props = _ref.props,
      props = _ref$props === undefined ? {} : _ref$props,
      _ref$Fallback = _ref.Fallback,
      Fallback = _ref$Fallback === undefined ? null : _ref$Fallback;

  var getLicenseProfileCheck = function getLicenseProfileCheck(componentProps, currentPermission, currentLicense) {
    var permissionCheckWithProfile = permissionCheck(currentPermission);
    var licenseSuccess = licenseCheck(currentLicense)(component.license);
    var permissionSuccess = permissionCheckWithProfile(component.permission);
    var permissionProps = _Object$keys(props).reduce(function (res, next) {
      if (props[next] instanceof Array) {
        res[next] = props[next].map(function (permissionObj, i) {
          if (permissionCheckWithProfile(permissionObj.permission)) {
            return permissionObj.obj;
          }
        }).filter(function (permission) {
          return permission;
        });
        return res;
      } else if (typeof props[next] === 'function') {
        permissionObj = props[next](componentProps);

        if (permissionCheckWithProfile(permissionObj.permission)) {
          res[next] = permissionObj.obj;
        } else if (permissionObj.falseObj) {
          res[next] = permissionObj.falseObj;
        }
        return res;
      }
      var permissionObj = props[next];
      if (permissionCheckWithProfile(permissionObj.permission)) {
        res[next] = permissionObj.obj;
      } else {
        res[next] = permissionObj.falseObj;
      }
      return res;
    }, {});
    return { licenseSuccess: licenseSuccess, permissionSuccess: permissionSuccess, permissionProps: permissionProps };
  };
  var proxyPropsObjHasFunction = _Object$keys(props).some(function (key) {
    return typeof props[key] === 'function';
  });

  return function (ChildComponent) {
    function Wrapper(props) {
      return React.createElement(HigherOrderPermission, _extends({}, props, {
        proxyPropsObjHasFunction: proxyPropsObjHasFunction,
        getLicenseProfileCheck: getLicenseProfileCheck,
        Component: ChildComponent,
        Fallback: Fallback
      }));
    }
    return Wrapper;
  };
};

export var urlLicensePermissionCheckHOC = function urlLicensePermissionCheckHOC(ob) {
  ob.Fallback = InsufficientPrivileges;
  return licensePermissionCheckHOC(ob);
};