import _slicedToArray from 'babel-runtime/helpers/slicedToArray';
export var underScoreSplit = function underScoreSplit(str) {
  return str.split('_');
};

var logicModulePermission = function logicModulePermission(permissionApi, modulePermission) {
  var length = modulePermission.length,
      resultString = [],
      j = 0,
      result = void 0;
  for (var i = 0; i < length; i++) {
    if (modulePermission.charAt(i) != '&' && modulePermission.charAt(i) != '|') {
      if (typeof resultString[j] == 'undefined') {
        resultString[j] = '';
      }
      resultString[j] = '' + resultString[j] + modulePermission.charAt(i);
    } else {
      j = j + 1;
      resultString[j] = '' + modulePermission.charAt(i) + modulePermission.charAt(i);
      i = i + 1;
      j = j + 1;
    }
  }
  while (resultString.length > 1 || resultString.length == 1 && resultString[0] != 'true' && resultString[0] != 'false') {
    var _resultString = resultString,
        _resultString2 = _slicedToArray(_resultString, 3),
        arg1 = _resultString2[0],
        operator = _resultString2[1],
        _resultString2$ = _resultString2[2],
        arg2 = _resultString2$ === undefined ? '*' : _resultString2$;

    arg1 = arg1.replace(/ /g, ''), arg2 = arg2.replace(/ /g, '');
    arg1 = arg1 == 'true' ? true : arg1 == 'false' ? false : singleModulePermissionCheck(permissionApi)(arg1);
    arg2 = arg2 == 'true' ? true : arg2 == 'false' ? false : singleModulePermissionCheck(permissionApi)(arg2 || '*');
    result = operator == '&&' ? arg1 && arg2 : operator == '||' ? arg1 || arg2 : arg1;
    resultString = ['' + result].concat(resultString.slice(3));
  }
  if (typeof result == 'undefined' && resultString.length == 1) {
    result = resultString[0] == 'true' ? true : false;
  }
  return result;
};

export var permissionCheck = function permissionCheck(permissionApi) {
  return function (modulePermission) {
    var success = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
    var failure = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

    var permissionString = modulePermission;
    while (permissionString.indexOf(')') != -1) {
      var endBracketIndex = permissionString.indexOf(')'),
          startBracketIndex = permissionString.lastIndexOf('(', endBracketIndex);
      permissionString = '' + permissionString.substring(0, startBracketIndex) + logicModulePermission(permissionApi, permissionString.substring(startBracketIndex + 1, endBracketIndex)) + permissionString.substring(endBracketIndex + 1);
    }
    var result = logicModulePermission(permissionApi, permissionString);
    return result ? success : failure;
  };
};

export var singleModulePermissionCheck = function singleModulePermissionCheck() {
  var permissionApi = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return function (modulePermission) {
    var success = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
    var failure = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

    var _underScoreSplit = underScoreSplit(modulePermission || '*'),
        _underScoreSplit2 = _slicedToArray(_underScoreSplit, 2),
        module = _underScoreSplit2[0],
        permission = _underScoreSplit2[1];

    if (module == '*' && typeof permission == 'undefined') {
      return success;
    }

    if (permissionApi[module]) {
      var validation = permissionApi[module][permission] ? permissionApi[module][permission] : permissionApi[module].flags && permissionApi[module].flags[permission] ? permissionApi[module].flags[permission] : false;
      if (validation) {
        return success;
      } else {
        return failure;
      }
    } else {
      var validation = permissionApi.flags && permissionApi.flags[permission] || null;
      if (validation) {
        return success;
      } else {
        return failure;
      }
    }
  };
};
export var licenseCheck = function licenseCheck() {
  var licenseObj = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return function (license) {
    var success = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
    var failure = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
    var licenseType = licenseObj.licenseType;

    if (license == '*') {
      return success;
    }
    if (license.constructor == Array && license.indexOf(licenseType) != -1) {
      return success;
    } else if (licenseType == license) {
      return success;
    } else {
      return failure;
    }
  };
};