'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _trash, _notAccessible;

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/*

In that array,
0th position contains the value for isShow
1st position contains the value for isReadOnly

*/

var rules = {
  tickets: {
    isSpam: {
      secondaryContact: [1, 1],
      leftPanelForm: [1, 1],
      replyAssistant: [0, 0],
      suggestedSolution: [0, 0],
      timeline: [1, 1],
      mergeTicket: [0, 0],
      marketPlace: [0, 0],
      replyActions: [0, 0],
      followers_view: [1, 0],
      followers_add: [1, 1],
      tags_view: [1, 0],
      tags_add: [1, 1],
      shareCount: [1, 0],
      forWardOnly: [0, 0],
      moreActions: [1, 0],
      addTask: [0, 0],
      footer: [1, 0],
      edit: [0, 0],
      status: [1, 1],
      assignee: [1, 1],
      dueDate: [1, 1],
      responseDueDate: [1, 1],
      add_comment: [0, 0],
      edit_approval: [0, 0],
      add_timeentry_invoice: [0, 0]
    },
    bluePrint: {
      status: [1, 1],
      move: [1, 0]
    },
    ticketSharingList: {
      edit: [0, 0],
      delete: [0, 0],
      status: [1, 1],
      assign: [1, 1],
      peek: [1, 0],
      move: [1, 1],
      mass_action: [1, 1]
    },
    spam: {
      edit: [0, 0],
      show_comment: [0, 0],
      status: [1, 1],
      assign: [1, 1],
      peek: [1, 0],
      delete: [1, 0],
      move: [1, 1]
    },
    spamContact: {
      booksInteg: [0, 0],
      invoiceInteg: [0, 0],
      jira: [0, 0],
      bugtracker: [0, 0],
      add_timeentry_invoice: [0, 0]
    },
    anonymousContact: {
      booksInteg: [0, 0],
      invoiceInteg: [0, 0],
      jira: [0, 0],
      bugtracker: [0, 0],
      add_timeentry_invoice: [0, 0]
    },
    trash: (_trash = {
      edit: [0, 0],
      peek: [0, 0],
      delete: [0, 0],
      show_comment: [0, 0],
      status: [1, 1],
      assign: [1, 1]
    }, _defineProperty(_trash, 'peek', [1, 0]), _defineProperty(_trash, 'move', [1, 1]), _trash),
    notAccessible: (_notAccessible = {
      edit: [0, 0],
      peek: [0, 0],
      delete: [0, 0],
      show_comment: [0, 0],
      status: [1, 1],
      assign: [1, 1]
    }, _defineProperty(_notAccessible, 'peek', [1, 0]), _defineProperty(_notAccessible, 'move', [1, 1]), _defineProperty(_notAccessible, 'mass_action', [1, 1]), _notAccessible)
  },

  contacts: {
    anonymous: {
      edit: [0, 0],
      follow: [0, 0],
      add_tickets: [0, 0],
      add_products: [0, 0],
      add_attachments: [0, 0],
      delete_attachments: [0, 0],
      add_activies: [0, 0],
      add_comment: [0, 0],
      edit_comment: [0, 0],
      mass_action: [1, 1],
      massUpdate: [0, 0],
      massMerge: [0, 0],
      booksInteg: [0, 0],
      invoiceInteg: [0, 0],
      add_timeentry_invoice: [0, 0],
      add_as_enduser: [0, 0],
      update_from_crm: [0, 0],
      mark_as_spam: [0, 0],
      crmPanel: [0, 0]
    },
    spam: {
      edit: [0, 0],
      add_tickets: [0, 0],
      massUpdate: [0, 0],
      massMerge: [0, 0],
      follow: [0, 0],
      add_call: [0, 0],
      add_activies: [0, 0],
      add_timentry: [0, 0],
      edit_timeentry: [0, 0],
      delete_timeentry: [0, 0],
      remove_products: [0, 0],
      add_products: [0, 0],
      add_attachments: [0, 0],
      delete_attachments: [0, 0],
      add_comment: [0, 0],
      edit_comment: [0, 0],
      delete_comment: [0, 0],
      add_as_enduser: [0, 0],
      update_from_crm: [0, 0],
      booksInteg: [0, 0],
      invoiceInteg: [0, 0],
      add_timeentry_invoice: [0, 0],
      comment_more: [0, 0],
      crmPanel: [0, 0]
    },
    trash: {
      edit: [0, 0],
      delete: [0, 0],
      add_tickets: [0, 0],
      massUpdate: [0, 0],
      massMerge: [0, 0],
      open: [0, 0]
    }
  },

  accounts: {
    spamContacts: {
      disassociate: [0, 0]
    }
  },

  tasks: {}
};

var ticketSharingPermisionRules = {
  TS_READ_WRITE: {
    timeline: [0, 0],
    leftPanelForm: [1, 0],
    followers_view: [1, 0],
    followers_add: [1, 1],
    tags_view: [1, 0],
    tags_add: [1, 1],
    shareCount: [1, 0],
    forWardOnly: [0, 0],
    moreActions: [0, 0],
    addTask: [0, 0],
    footer: [0, 0],
    edit: [0, 0],
    status: [1, 1],
    assignee: [1, 1],
    dueDate: [1, 1],
    responseDueDate: [1, 1],
    booksInteg: [0, 0],
    invoiceInteg: [0, 0],
    jira: [0, 0],
    bugtracker: [0, 0]
  },
  TS_RESTRICTED_ACCESS: {
    timeline: [0, 0],
    leftPanelForm: [0, 0],
    followers_view: [0, 0],
    followers_add: [0, 0],
    tags_view: [0, 0],
    tags_add: [0, 0],
    shareCount: [0, 0],
    forWardOnly: [1, 0],
    moreActions: [0, 0],
    addTask: [0, 0],
    footer: [0, 0],
    edit: [0, 0],
    status: [1, 1],
    assignee: [1, 1],
    dueDate: [1, 1],
    responseDueDate: [1, 1],
    booksInteg: [0, 0],
    invoiceInteg: [0, 0],
    jira: [0, 0],
    bugtracker: [0, 0]
  },
  TS_READ_ONLY: {
    timeline: [0, 0],
    leftPanelForm: [1, 0],
    followers_view: [1, 0],
    followers_add: [1, 1],
    tags_view: [1, 0],
    tags_add: [1, 1],
    shareCount: [1, 0],
    forWardOnly: [0, 0],
    moreActions: [0, 0],
    addTask: [0, 0],
    footer: [0, 0],
    edit: [0, 0],
    status: [1, 1],
    assignee: [1, 1],
    dueDate: [1, 1],
    responseDueDate: [1, 1],
    booksInteg: [0, 0],
    invoiceInteg: [0, 0],
    jira: [0, 0],
    bugtracker: [0, 0]
  }
};

rules.tickets = Object.assign({}, rules.tickets, ticketSharingPermisionRules);

var restrictionRules = exports.restrictionRules = rules;

var lockMessages = exports.lockMessages = {
  tickets: {
    TS_READ_WRITE: {
      status: 'support.ticketshare.field.locked',
      assignee: 'support.ticketshare.field.locked',
      dueDate: 'support.ticketshare.field.locked',
      responseDueDate: 'support.ticketshare.field.locked'
    },
    TS_RESTRICTED_ACCESS: {
      status: 'support.ticketshare.field.locked',
      assignee: 'support.ticketshare.field.locked',
      dueDate: 'support.ticketshare.field.locked',
      responseDueDate: 'support.ticketshare.field.locked'
    },
    TS_READ_ONLY: {
      status: 'support.ticketshare.field.locked',
      assignee: 'support.ticketshare.field.locked',
      dueDate: 'support.ticketshare.field.locked',
      responseDueDate: 'support.ticketshare.field.lock ed'
    },
    bluePrint: {
      status: 'support.blueprints.status.lock.msg'
    }
  }
};