'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getRestriction = exports.getRestrictionObj = undefined;

var _RestrictionValidatorRules = require('./RestrictionValidatorRules');

var _selectn = require('selectn');

var _selectn2 = _interopRequireDefault(_selectn);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getRestrictionObj = exports.getRestrictionObj = function getRestrictionObj() {
  var features = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var module = arguments[1];
  var action = arguments[2];

  var perLen = features.length;
  var resObj = { isShow: true, isReadOnly: false };
  var moduleActionValues = _RestrictionValidatorRules.restrictionRules[module];
  if (features.length) {
    for (var i = 0; i < perLen; i++) {
      if (moduleActionValues[features[i]][action] !== undefined) {
        var resVal = moduleActionValues[features[i]][action];
        if (!resVal[0]) {
          resObj.isReadOnly = resVal[1] != undefined ? Boolean(resVal[1]) : false;
          resObj.isShow = resVal[0] != undefined ? Boolean(resVal[0]) : false;
          break;
        } else if (resVal[1]) {
          resObj.isReadOnly = resVal[1] != undefined ? Boolean(resVal[1]) : true;
          resObj.isShow = resVal[0] != undefined ? Boolean(resVal[0]) : true;
          resObj.readOnlyMessage = resVal[1] ? (0, _selectn2.default)(module + '[' + features[i] + '][' + action + ']', _RestrictionValidatorRules.lockMessages) : '';
        }
      } else {
        continue;
      }
    }
  }
  return resObj;
};

var getRestriction = exports.getRestriction = function getRestriction(features, module, action) {
  return getRestrictionObj(features, module, action);
};